/*Some commonly used functions*/
/*Mark Watson 2/2000*/

#include "mga_std.h"
#include <stdarg.h>

/*delays in multiple of microseconds*/
void delay(bigtime_t i)
{
	bigtime_t start=system_time();
	while(system_time()-start<i);
}

/*debug logging*/
void LOG(int level,char *fmt, ...)
{
	FILE * myhand;
	va_list args;
	char * p;

	/*LOOK HERE look here LOOK HERE*/
	/*---- ---- --------- ---- ----*/
	/*change to "if (level<0) return;" to enable log file*/
	if (level<3) return;

	myhand=fopen("/boot/home/driver.log","a+");
	
	va_start(args,fmt);
	for(p=fmt;*p;p++)
	{
		if (*p!='%')
		{
			putc(*p,myhand);
			continue;
		}
		switch(*++p)
		{
		case 'd':
			fprintf(myhand,"%d",(int)va_arg(args,uint32));
			break;
		case 'x':
			fprintf(myhand,"%x",(int)va_arg(args,uint32));
			break;
		case 'f':
			fprintf(myhand,"%f",(double)va_arg(args,double));
			break;
		case 's':
			fprintf(myhand,"%s",(char *)va_arg(args,char *));
		}
	}

	fclose(myhand);
}
